package com.zipcodewilmington;

import com.sun.tools.javac.util.ArrayUtils;

import java.sql.SQLOutput;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {

        String firstElement = array[0];
        return firstElement;
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {

        String secondElement = array[1];
        return secondElement;
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {

        String lastElement = array[array.length - 1];
        return lastElement;
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {

        String secondToLastElement = array[array.length - 2];
        return secondToLastElement;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        Arrays.asList(array).contains(value);
        return true;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String tmp;
        for (int i = 0; i < array.length / 2; i++) {
            tmp = array[i];
            array[i] = array[array.length - 1 - i];
            array[array.length - 1 - i] = tmp;
        }

        //System.out.println(array);

        return array;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        int i1 = 0;
        int i2 = array.length - 1;

        while (i2 > i1) {
            if (array[i1] != array[i2]) {
                return false;
            }
            ++i1;
            --i2;
        }


        return true;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        String str = String.join("", array).toLowerCase();
        for (char i = 'a'; i <= 'z'; i++) {
            if (str.contains(String.valueOf(i))) {
                continue;
            } else {
                return false;
            }
        }
        return true;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int counter = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i].contains(value)) {
                counter++;
            }
        }
        return counter;
    }


    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        String[] newArr = new String[array.length - 1];
        int counter = 0;
        for (String i : array) {
            if (!i.equals(valueToRemove)) {
                newArr[counter++] = i;
            }
        }
        return newArr;
    }


    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        ArrayList<String> newArray = new ArrayList<>();

        newArray.add(array[0]);
        String last = array[0];

        for (int i = 1; i < array.length; i++) {
            String nextWord = array[i];
            if (nextWord.equals(last)) {
                newArray.set(newArray.size() - 1, newArray.get(newArray.size() - 1));
            } else {
                newArray.add(nextWord);
                last = nextWord;
            }
        }


        return newArray.toArray(new String[newArray.size() - 1]);
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {

        ArrayList<String> newArray = new ArrayList<>();

        newArray.add(array[0]);
        String last = array[0];

        for (int i = 1; i < array.length; i++) {
            String nextWord = array[i];
            if (nextWord.equals(last)) {
                newArray.set(newArray.size() - 1, newArray.get(newArray.size() - 1) + nextWord);
            } else {
                newArray.add(nextWord);
                last = nextWord;
            }
        }

        return newArray.toArray(new String[newArray.size() - 1]);
    }
}


